﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace WG_ChangeOtherColumnsBasedOnValue
{
    public partial class Form1 : Form
    {
        EditorWithText readOnlyEditorWithButton;

        Infragistics.Win.Appearance readOnlyAppearance;
        Infragistics.Win.Appearance normalAppearance;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("No", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Type", typeof(string));
            dt.Columns.Add("FileName/Value", typeof(string));
            dt.Columns.Add("Blink", typeof(bool));

            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});
            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});
            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});
            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});
            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});
            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});
            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});
            dt.Rows.Add(new object[] { null,String.Empty, String.Empty, DBNull.Value});

            ultraGrid1.DataSource = dt;

            ultraComboEditor1.ValueList = GetValues();

        }

        private ValueList GetValues()
        {
            ValueList vl = new ValueList();

            vl.ValueListItems.Add("Text");
            vl.ValueListItems.Add("Image");

            return vl;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var band = e.Layout.Bands[0];
            band.Columns["Type"].EditorComponent = ultraComboEditor1;
            band.Columns["Type"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;

            band.Columns["FileName/Value"].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
        }

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Key != "Type")
                return;

            switch (e.Cell.Text)
            {
                case "Text":
                    e.Cell.Row.Cells["Blink"].Value = true;
                    e.Cell.Row.Cells["FileName/Value"].Editor = null;
                    e.Cell.Row.Cells["FileName/Value"].Activation = Activation.AllowEdit;
                    e.Cell.Row.Cells["FileName/Value"].Appearance = this.NormalAppearance;
                    e.Cell.Row.Cells["FileName/Value"].ActiveAppearance = this.NormalAppearance;
                    break;

                case "Image":
                    e.Cell.Row.Cells["Blink"].Value = false;
                    e.Cell.Row.Cells["FileName/Value"].Activation = Activation.ActivateOnly;
                    e.Cell.Row.Cells["FileName/Value"].Editor = this.ReadOnlyEditorWithButton;
                    e.Cell.Row.Cells["FileName/Value"].Appearance = this.ReadOnlyAppearance;
                    e.Cell.Row.Cells["FileName/Value"].ActiveAppearance = this.ReadOnlyAppearance;
                    break;
            }
        }

        private EditorWithText ReadOnlyEditorWithButton
        {
            get 
            {
                if (this.readOnlyEditorWithButton == null)
                {
                    readOnlyEditorWithButton = new EditorWithText();
                    var button = new EditorButton();
                    button.Text = "...";
                    button.Width = 23;
                    button.Click += button_Click;
                    readOnlyEditorWithButton.ButtonsRight.Add(button);
                }

                return this.readOnlyEditorWithButton; 
            }
        }

        private Infragistics.Win.Appearance ReadOnlyAppearance
        {
            get 
            {
                if (this.readOnlyAppearance == null)
                {
                    readOnlyAppearance = new Infragistics.Win.Appearance();
                    readOnlyAppearance.BackColor = Color.LightGray;
                }
                return readOnlyAppearance; 
            }
        }

        private Infragistics.Win.Appearance NormalAppearance
        {
            get 
            {
                if (normalAppearance == null)
                    normalAppearance = new Infragistics.Win.Appearance();
                return normalAppearance; 
            }
        }


        void button_Click(object sender, EditorButtonEventArgs e)
        {
            MessageBox.Show("Handle button click");
        }
    }
}
